% ply: ply file with vertices and faces
% n: degree number
% c: 3L distance
% ExpectAcc: stopping error
% NumBasis: maxmum number of bases
% kapa: for RR method

function [Ma, RRa, list3d] = IncrFitting3d(ply, n, c, ExpectAcc, NumBasis, kapa)
% path(path, '../');
% [ply]=Resample(ply, 10);
[num_point] = size(ply.v,1);
[l1, l2] = Generate3L(ply, c);
Vert = [ l1; l2; ply.v];
%for zero level set
% M1 = NthMono3d(ply.v,n);
% %for inner level
% M2 = NthMono3d(l1,n);
% %for outer level
% M3 = NthMono3d(l2,n);
Mb = [-c*ones(num_point, 1); c*ones(num_point, 1);zeros(num_point, 1)];
l3d=Listing(n,0);
% for nl=1:n,
%     currentList = getMonoL(nl, n);
%     ListLen = size(currentList, 1);
%     currentL = [currentList zeros(ListLen,1)];
%     currentG = [currentList(:,1:3) zeros(ListLen,1) currentList(:,4)];
%     list5d = [list5d; currentL; currentG];
% end


%% initialization
num_max = 1000;
Q = ones(3*num_point,1);
% U = eye(3*num_point);
V=zeros(3*num_point, num_max);
Mcoli = 1;
Qcoli = 1;
R = zeros(num_max,num_max);
R(1,1)=1;
ind = 1;
err=[];
err2=[];
% choose the max order for IP
list=l3d;
colnorm = norm(Q);
Q=Q/colnorm;
% U(:,1)=Q;
k=2;
Bnorm = norm(Mb);
Mb = Mb./Bnorm;
qb=Mb;
% ExpectAcc=.47;
disp(sprintf('\n stopping error=%0.5g', (1-ExpectAcc^2)/num_point));
qbnorm = 0;
% figure(1);cla;hold on;
while Qcoli < NumBasis && qbnorm < ExpectAcc && Mcoli<=size(list,1),
    m1 = getOneColumIP(Vert, list(Mcoli,:));
    M(:,Mcoli)=m1;
    m1n=norm(m1);
    m1 = m1/m1n;
%% 
% Qcoli
    ttqb_2=qb(Qcoli:end);
    [r] = MHT(V, m1, Qcoli, qb);
    qb_k = qb(Qcoli);
%     if (Qcoli==1) || (abs(r(Qcoli))*qb_k^2>1e-4),
    if (Qcoli==1) || (abs(r(Qcoli))*qb_k^2>0),
        R(1:Qcoli,Qcoli) = r;
        qbnorm=norm(qb(1:Qcoli));
        if Qcoli==1
            colnorm=m1n;
            ind=1;
        else
           colnorm=[colnorm; m1n];
           ind=[ind;Mcoli];
        end
       %% calculate errors
%         err=[err; (1-qbnorm^2)/num_point];
        err=[err; 1-qbnorm];
        R_test=R(1:Qcoli,1:Qcoli);
        qb_test=qb(1:Qcoli);
        Ma = Bnorm.*R_test\qb_test./colnorm;
%         Ma = Bnorm.*Ma./colnorm;
        resdual=M(:,ind)*Ma-Bnorm.*Mb;
        err2=[err2; norm(resdual)];
        Qcoli = Qcoli + 1;
    else
%        V(:,Qcoli)=0;
       qb(Qcoli:end)=ttqb_2;
    end
    Mcoli = Mcoli + 1;
end
disp(sprintf('\n norm(qb) = %0.5g, final error=%0.5g, num. of basis=%d', qbnorm, err(end), Qcoli-1));
R_IP=R(1:Qcoli-1,1:Qcoli-1);
qb_IP=qb(1:Qcoli-1);
Ma = R_IP\qb_IP;
Ma = Bnorm.*Ma./colnorm;
list3d = list(ind,:);
figure(2);hold on; 
plot(err,'-r*');
%% plot out fitting result   
intv=(max(ply.v(:))-min(ply.v(:)))/50;
figure(3); hold on;
plot3(ply.v(1:num_point,1), ply.v(1:num_point,2), ply.v(1:num_point,3),'.');
% showLevel3dIP(Ma, list(ind,:), [min(ply.v(:,1)) max(ply.v(:,1)); min(ply.v(:,2)) max(ply.v(:,2)); min(ply.v(:,3)) max(ply.v(:,3))], .1);

%% adding RR method
[dd] = Dll_3d(ply.v(1:num_point,:), list(ind,:));
D=diag(dd./(colnorm.^2));
RD=R_IP'\D;
TR=R_IP+kapa*RD;
Ma2=TR\qb_IP;
Ma2 = Bnorm.*Ma2./colnorm;
showLevel3dIP(Ma2, list(ind,:), [min(ply.v(:,1)) max(ply.v(:,1)); min(ply.v(:,2)) max(ply.v(:,2)); min(ply.v(:,3)) max(ply.v(:,3))], intv);
IPList = list(ind,:);

RRa=Ma2;


function [ply]=Resample(ply, interv)
ply.v=ply.v(1:interv:end,:);
ply.n=ply.n(1:interv:end,:);


function [l1, l2] = Generate3L(ply, c)
    points = ply.v;
    normal = ply.n;
	num_points = size(points,1);
	l1 = zeros(num_points,3);
	l2 = zeros(num_points,3);
	for i=1: num_points,
		dis = c*normal(i, :);
		l1(i, :) = points(i, :) - dis;
		l2(i, :) = points(i, :) + dis;
	end
%function end


%construct monomial matrix for 3D points with degree n
function [M] = NthMono3d(points, n)
[l] = size(Listing(n,0),1);
n_p = size(points,1);
M = zeros(n_p, l);
k = 1;
for j = 0:n, % 3d leading form
    for i = 0:j, % 2d all
        for c = 0:i, % 2d leading
            b = i-c;
            a = j-b-c;
            M(:,k) = (points(:,1).^a) .* (points(:,2).^b) .* (points(:,3).^c);
            k=k+1;
        end
    end
end
%function end

function [m] = getOneColumIP(points, list)
m = ones(size(points,1),1);
for i = 1:length(list),
    m = m .* points(:,i).^list(i);
end

