%function [F, V]=showLevel(c, n, scl, interval, level)
%This function is for showing a 3L implicit impolynomial when inputing the cofficient c and degree n.
%parameter:	c: coefficient of the polynomial.
%parameter:	n: degree of the polynomial
%parameter:	dis: distance between the layers
function [Vt]=showLevel3dIP(c, list, scl, interval)
    %[scl]=GetPlyRange2d(ply.v);
    if size(scl,1) > 1,
        x1 = scl(1,1):interval:scl(1,2);
        x2 = scl(2,1):interval:scl(2,2);
        x3 = scl(3,1):interval:scl(3,2);
    else
        x1 = -scl:interval:scl;
        x2 = -scl:interval:scl;
        x3 = -scl:interval:scl;
    end
	[X1,X2,X3] = ndgrid(x1,x2,x3);
	[z] = NthMono3d(X1, X2, X3, c, list);
    [F, V] = isosurface(X1, X2, X3, z, 0);
    trisurf(F,V(:,1), V(:,2), V(:,3));
    
%     contour3(X1, X2, z, [-2.5:.3:1]);
    hold on;
    %surf(X1,X2, z, z);
%     hold on;
    %surf(X1,X2, zeros(numX,numY));
    %[c,h]=contour(X1, X2, z, [0, 0]);
    %set(h,'LineWidth',2);
    %hold off;
    %plot(ply.v(:,1),ply.v(:,2),'.r');
    %colormap([0 0 0]);
    %Vt=findMainC(c);
    %[Vt, Nt] = findAllC(c);
    %[Vt, Nt] = findAllC(c);
    axis equal;
    %axis off;
    %butterfly
    %axis([-1.8 1.4 -1.7 1.4]);
    %axis([scl(1,:) scl(2,:)].*1.3);
    %cell
%     axis([scl(1,1) scl(1,2) scl(2,1) scl(2,2)]);
%     hold off;
    
    
function [M] = NthMono3d(X, Y, Z, coef, list)
n_c=size(list,1);
M = X.*0;
for i = 1:n_c,
    M = M + coef(i)*(X.^list(i,1)).*(Y.^list(i,2)).*(Z.^list(i,3));
end
